#!/bin/bash 

echo "Building the MCB application with MPC and GNU"
sed -e "s@^MCB_ROOT_DIR=.*@MCB_ROOT_DIR=$PWD@" Makefile-linux-x86_64.mpc_gnu > Makefile-linux-x86_64

# We need to use patched versions of some of the source files. These are already preprocessed.
PATCHED_SRC="src/ImplicitMonteCarlo/IMCInst.cc src/ImplicitMonteCarlo/IMC_4MomentumInst.cc src/ImplicitMonteCarlo/photonInst.cc src/AbsorptionOpacity/constant_absorp_opac.cc src/AbsorptionOpacity/Opacity_data_baseInst.cc src/AbsorptionOpacity/Analytic_opacity_data_baseInst.cc src/Sources/Source_data_baseInst.cc src/Sources/Domain_photon_sourceInst.cc src/Sources/isotropic_sourceInst.cc src/Material/Material_data_baseInst.cc src/BoundaryConditions/transmitting_BCInst.cc src/BoundaryConditions/Domain_BCInst.cc src/BoundaryConditions/Domain_BCInst.cc src/BoundaryConditions/reflecting_BCInst.cc src/BoundaryConditions/BC_listInst.cc src/Meshes/Ortho_Cartesian_2D_Mesh.cc src/Meshes/zcfInst.cc src/Meshes/fcfInst.cc src/DomainDecomposition/IMC_Domain_organizerInst.cc src/DomainDecomposition/Domain_organizerInst.cc src/DomainDecomposition/Domain_exchangeInst.cc src/DomainDecomposition/setDomainInformationInst.cc src/DomainDecomposition/sumOverDomainsInst.cc src/UtilityFunctions/rotate_anglesInst.cc src/StandAloneMains/MCBenchmark.cc src/StandAloneMains/MCBenchmark.cc"

# Patch the source code:
for i in ${PATCHED_SRC}
do 
  cp ${i}.mpc_gnu ${i}
done
./build-linux-x86_64.sh
cp src/MCBenchmark.exe src/MCBenchmark.mpc.exe
echo "Running the MCB application with MPC and GNU"
./run.mpc.sh

# Copy the original files back
for i in ${PATCHED_SRC}
do 
  cp ${i}.orig  $i
done
